/[gentoo-x86]/eclass/linux-info.eclass
Gentoo

Diff of /eclass/linux-info.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.1 Revision 1.81
1# Copyright 1999-2004 Gentoo Foundation 1# Copyright 1999-2006 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/linux-info.eclass,v 1.1 2004/11/24 16:36:38 johnm Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/linux-info.eclass,v 1.81 2010/01/10 09:26:09 robbat2 Exp $
4# 4#
5# This eclass provides functions for querying the installed kernel 5# Original author: John Mylchreest <johnm@gentoo.org>
6# source version, selected kernel options etc. 6# Maintainer: kernel-misc@gentoo.org
7# 7#
8# Please direct your bugs to the current eclass maintainer :)
8 9
9ECLASS=linux-info 10# @ECLASS: linux-info.eclass
10INHERITED="$INHERITED $ECLASS" 11# @MAINTAINER:
12# kernel-misc@gentoo.org
13# @BLURB: eclass used for accessing kernel related information
14# @DESCRIPTION:
15# This eclass is used as a central eclass for accessing kernel
16# related information for source or binary already installed.
17# It is vital for linux-mod.eclass to function correctly, and is split
18# out so that any ebuild behaviour "templates" are abstracted out
19# using additional eclasses.
20#
21# "kernel config" in this file means:
22# The .config of the currently installed sources is used as the first
23# preference, with a fall-back to bundled config (/proc/config.gz) if available.
24
25# A Couple of env vars are available to effect usage of this eclass
26# These are as follows:
27
28# @ECLASS-VARIABLE: KERNEL_DIR
29# @DESCRIPTION:
30# A string containing the directory of the target kernel sources. The default value is
31# "/usr/src/linux"
32
33# @ECLASS-VARIABLE: CONFIG_CHECK
34# @DESCRIPTION:
35# A string containing a list of .config options to check for before
36# proceeding with the install.
37#
38# e.g.: CONFIG_CHECK="MTRR"
39#
40# You can also check that an option doesn't exist by
41# prepending it with an exclamation mark (!).
42#
43# e.g.: CONFIG_CHECK="!MTRR"
44#
45# To simply warn about a missing option, prepend a '~'.
46# It may be combined with '!'.
47#
48# In general, most checks should be non-fatal. The only time fatal checks should
49# be used is for building kernel modules or cases that a compile will fail
50# without the option.
51#
52# This is to allow usage of binary kernels, and minimal systems without kernel
53# sources.
54
55# @ECLASS-VARIABLE: ERROR_<CFG>
56# @DESCRIPTION:
57# A string containing the error message to display when the check against CONFIG_CHECK
58# fails. <CFG> should reference the appropriate option used in CONFIG_CHECK.
59#
60# e.g.: ERROR_MTRR="MTRR exists in the .config but shouldn't!!"
61
62# @ECLASS-VARIABLE: KBUILD_OUTPUT
63# @DESCRIPTION:
64# A string passed on commandline, or set from the kernel makefile. It contains the directory
65# which is to be used as the kernel object directory.
66
67# There are also a couple of variables which are set by this, and shouldn't be
68# set by hand. These are as follows:
69
70# @ECLASS-VARIABLE: KV_FULL
71# @DESCRIPTION:
72# A read-only variable. It's a string containing the full kernel version. ie: 2.6.9-gentoo-johnm-r1
73
74# @ECLASS-VARIABLE: KV_MAJOR
75# @DESCRIPTION:
76# A read-only variable. It's an integer containing the kernel major version. ie: 2
77
78# @ECLASS-VARIABLE: KV_MINOR
79# @DESCRIPTION:
80# A read-only variable. It's an integer containing the kernel minor version. ie: 6
81
82# @ECLASS-VARIABLE: KV_PATCH
83# @DESCRIPTION:
84# A read-only variable. It's an integer containing the kernel patch version. ie: 9
85
86# @ECLASS-VARIABLE: KV_EXTRA
87# @DESCRIPTION:
88# A read-only variable. It's a string containing the kernel EXTRAVERSION. ie: -gentoo
89
90# @ECLASS-VARIABLE: KV_LOCAL
91# @DESCRIPTION:
92# A read-only variable. It's a string containing the kernel LOCALVERSION concatenation. ie: -johnm
93
94# @ECLASS-VARIABLE: KV_DIR
95# @DESCRIPTION:
96# A read-only variable. It's a string containing the kernel source directory, will be null if
97# KERNEL_DIR is invalid.
98
99# @ECLASS-VARIABLE: KV_OUT_DIR
100# @DESCRIPTION:
101# A read-only variable. It's a string containing the kernel object directory, will be KV_DIR unless
102# KBUILD_OUTPUT is used. This should be used for referencing .config.
103
104# And to ensure all the weirdness with crosscompile
105inherit toolchain-funcs versionator
106
107EXPORT_FUNCTIONS pkg_setup
108
109DEPEND=""
110RDEPEND=""
11 111
12# Overwritable environment Var's 112# Overwritable environment Var's
13# --------------------------------------- 113# ---------------------------------------
14KERNEL_DIR="${KERNEL_DIR:-/usr/src/linux}" 114KERNEL_DIR="${KERNEL_DIR:-${ROOT}usr/src/linux}"
15 115
16 116
117# Bug fixes
118# fix to bug #75034
119case ${ARCH} in
120 ppc) BUILD_FIXES="${BUILD_FIXES} TOUT=${T}/.tmp_gas_check";;
121 ppc64) BUILD_FIXES="${BUILD_FIXES} TOUT=${T}/.tmp_gas_check";;
122esac
123
124# @FUNCTION: set_arch_to_kernel
125# @DESCRIPTION:
126# Set the env ARCH to match what the kernel expects.
127set_arch_to_kernel() { export ARCH=$(tc-arch-kernel); }
128# @FUNCTION: set_arch_to_portage
129# @DESCRIPTION:
130# Set the env ARCH to match what portage expects.
131set_arch_to_portage() { export ARCH=$(tc-arch); }
132
133# qeinfo "Message"
134# -------------------
135# qeinfo is a quiet einfo call when EBUILD_PHASE
136# should not have visible output.
137qout() {
138 local outputmsg type
139 type=${1}
140 shift
141 outputmsg="${@}"
142 case "${EBUILD_PHASE}" in
143 depend) unset outputmsg;;
144 clean) unset outputmsg;;
145 preinst) unset outputmsg;;
146 esac
147 [ -n "${outputmsg}" ] && ${type} "${outputmsg}"
148}
149
150qeinfo() { qout einfo "${@}" ; }
151qeerror() { qout eerror "${@}" ; }
17 152
18# File Functions 153# File Functions
19# --------------------------------------- 154# ---------------------------------------
20 155
21# getfilevar accepts 2 vars as follows: 156# @FUNCTION: getfilevar
22# getfilevar <VARIABLE> <CONFIGFILE> 157# @USAGE: variable configfile
23 158# @RETURN: the value of the variable
159# @DESCRIPTION:
160# It detects the value of the variable defined in the file configfile. This is
161# done by including the configfile, and printing the variable with Make.
162# It WILL break if your makefile has missing dependencies!
24getfilevar() { 163getfilevar() {
25local ERROR 164local ERROR basefname basedname myARCH="${ARCH}"
26 ERROR=0 165 ERROR=0
27 166
28 [ -z "${1}" ] && ERROR=1 167 [ -z "${1}" ] && ERROR=1
29 [ -z "${2}" ] && ERROR=1
30 [ ! -f "${2}" ] && ERROR=1 168 [ ! -f "${2}" ] && ERROR=1
31 169
32 if [ "${ERROR}" = 1 ] 170 if [ "${ERROR}" = 1 ]
33 then 171 then
172 echo -e "\n"
34 eerror "getfilevar requires 2 variables, with the second a valid file." 173 eerror "getfilevar requires 2 variables, with the second a valid file."
35 eerror " getfilevar <VARIABLE> <CONFIGFILE>" 174 eerror " getfilevar <VARIABLE> <CONFIGFILE>"
36 else 175 else
37 grep -e "^$1" $2 | sed 's: = :=:' | cut -d= -f2- 176 basefname="$(basename ${2})"
38 fi 177 basedname="$(dirname ${2})"
39} 178 unset ARCH
40 179
180 echo -e "e:\\n\\t@echo \$(${1})\\ninclude ${basefname}" | \
181 make -C "${basedname}" M="${S}" ${BUILD_FIXES} -s -f - 2>/dev/null
182
183 ARCH=${myARCH}
184 fi
185}
186
187# @FUNCTION: getfilevar_noexec
188# @USAGE: variable configfile
189# @RETURN: the value of the variable
190# @DESCRIPTION:
191# It detects the value of the variable defined in the file configfile.
192# This is done with sed matching an expression only. If the variable is defined,
193# you will run into problems. See getfilevar for those cases.
41getfilevar_isset() { 194getfilevar_noexec() {
195 local ERROR basefname basedname mycat myARCH="${ARCH}"
196 ERROR=0
197 mycat='cat'
198
199 [ -z "${1}" ] && ERROR=1
200 [ ! -f "${2}" ] && ERROR=1
201 [ "${2%.gz}" != "${2}" ] && mycat='zcat'
202
203 if [ "${ERROR}" = 1 ]
204 then
205 echo -e "\n"
206 eerror "getfilevar_noexec requires 2 variables, with the second a valid file."
207 eerror " getfilevar_noexec <VARIABLE> <CONFIGFILE>"
208 else
209 ${mycat} "${2}" | \
210 sed -n \
211 -e "/^[[:space:]]*${1}[[:space:]]*=[[:space:]]*\(.*\)\$/{
212 s,^[^=]*[[:space:]]*=[[:space:]]*,,g ;
213 s,[[:space:]]*\$,,g ;
214 p
215 }"
216 fi
217}
218
219# @PRIVATE-VARIABLE: _LINUX_CONFIG_EXISTS_DONE
220# @DESCRIPTION:
221# This is only set if one of the linux_config_*exists functions has been called.
222# We use it for a QA warning that the check for a config has not been performed,
223# as linux_chkconfig* in non-legacy mode WILL return an undefined value if no
224# config is available at all.
225_LINUX_CONFIG_EXISTS_DONE=
226
227linux_config_qa_check() {
228 local f="$1"
229 if [ -z "${_LINUX_CONFIG_EXISTS_DONE}" ]; then
230 ewarn "QA: You called $f before any linux_config_exists!"
231 ewarn "QA: The return value of $f will NOT gaurenteed later!"
232 fi
233}
234
235# @FUNCTION: linux_config_src_exists
236# @RETURN: true or false
237# @DESCRIPTION:
238# It returns true if .config exists in a build directory otherwise false
239linux_config_src_exists() {
240 export _LINUX_CONFIG_EXISTS_DONE=1
241 [ -s "${KV_OUT_DIR}/.config" ]
242}
243
244# @FUNCTION: linux_config_bin_exists
245# @RETURN: true or false
246# @DESCRIPTION:
247# It returns true if .config exists in /proc, otherwise false
248linux_config_bin_exists() {
249 export _LINUX_CONFIG_EXISTS_DONE=1
250 [ -s "/proc/config.gz" ]
251}
252
253# @FUNCTION: linux_config_exists
254# @RETURN: true or false
255# @DESCRIPTION:
256# It returns true if .config exists otherwise false
257#
258# This function MUST be checked before using any of the linux_chkconfig_*
259# functions.
260linux_config_exists() {
261 linux_config_src_exists || linux_config_bin_exists
262}
263
264# @FUNCTION: require_configured_kernel
265# @DESCRIPTION:
266# This function verifies that the current kernel is configured (it checks against the existence of .config)
267# otherwise it dies.
268require_configured_kernel() {
269 if ! linux_config_src_exists; then
270 qeerror "Could not find a usable .config in the kernel source directory."
271 qeerror "Please ensure that ${KERNEL_DIR} points to a configured set of Linux sources."
272 qeerror "If you are using KBUILD_OUTPUT, please set the environment var so that"
273 qeerror "it points to the necessary object directory so that it might find .config."
274 die "Kernel not configured; no .config found in ${KV_OUT_DIR}"
275 fi
276}
277
278# @FUNCTION: linux_chkconfig_present
279# @USAGE: option
280# @RETURN: true or false
281# @DESCRIPTION:
282# It checks that CONFIG_<option>=y or CONFIG_<option>=m is present in the current kernel .config
283# If linux_config_exists returns false, the results of this are UNDEFINED. You
284# MUST call linux_config_exists first.
285linux_chkconfig_present() {
286 linux_config_qa_check linux_chkconfig_present
42local RESULT 287 local RESULT
43 RESULT="$(getfilevar ${1} ${2})" 288 local config
289 config="${KV_OUT_DIR}/.config"
290 [ ! -f "${config}" ] && config="/proc/config.gz"
291 RESULT="$(getfilevar_noexec CONFIG_${1} "${config}")"
44 [ "${RESULT}" = "m" -o "${RESULT}" = "y" ] && return 0 || return 1 292 [ "${RESULT}" = "m" -o "${RESULT}" = "y" ] && return 0 || return 1
45} 293}
46 294
47getfilevar_ismodule() { 295# @FUNCTION: linux_chkconfig_module
296# @USAGE: option
297# @RETURN: true or false
298# @DESCRIPTION:
299# It checks that CONFIG_<option>=m is present in the current kernel .config
300# If linux_config_exists returns false, the results of this are UNDEFINED. You
301# MUST call linux_config_exists first.
302linux_chkconfig_module() {
303 linux_config_qa_check linux_chkconfig_module
48local RESULT 304 local RESULT
49 RESULT="$(getfilevar ${1} ${2})" 305 local config
306 config="${KV_OUT_DIR}/.config"
307 [ ! -f "${config}" ] && config="/proc/config.gz"
308 RESULT="$(getfilevar_noexec CONFIG_${1} "${config}")"
50 [ "${RESULT}" = "m" ] && return 0 || return 1 309 [ "${RESULT}" = "m" ] && return 0 || return 1
51} 310}
52 311
53getfilevar_isbuiltin() { 312# @FUNCTION: linux_chkconfig_builtin
313# @USAGE: option
314# @RETURN: true or false
315# @DESCRIPTION:
316# It checks that CONFIG_<option>=y is present in the current kernel .config
317# If linux_config_exists returns false, the results of this are UNDEFINED. You
318# MUST call linux_config_exists first.
319linux_chkconfig_builtin() {
320 linux_config_qa_check linux_chkconfig_builtin
54local RESULT 321 local RESULT
55 RESULT="$(getfilevar ${1} ${2})" 322 local config
323 config="${KV_OUT_DIR}/.config"
324 [ ! -f "${config}" ] && config="/proc/config.gz"
325 RESULT="$(getfilevar_noexec CONFIG_${1} "${config}")"
56 [ "${RESULT}" = "y" ] && return 0 || return 1 326 [ "${RESULT}" = "y" ] && return 0 || return 1
327}
328
329# @FUNCTION: linux_chkconfig_string
330# @USAGE: option
331# @RETURN: CONFIG_<option>
332# @DESCRIPTION:
333# It prints the CONFIG_<option> value of the current kernel .config (it requires a configured kernel).
334# If linux_config_exists returns false, the results of this are UNDEFINED. You
335# MUST call linux_config_exists first.
336linux_chkconfig_string() {
337 linux_config_qa_check linux_chkconfig_string
338 local config
339 config="${KV_OUT_DIR}/.config"
340 [ ! -f "${config}" ] && config="/proc/config.gz"
341 getfilevar_noexec "CONFIG_${1}" "${config}"
57} 342}
58 343
59# Versioning Functions 344# Versioning Functions
60# --------------------------------------- 345# ---------------------------------------
61 346
62# kernel_is returns true when the version is the same as the passed version 347# @FUNCTION: kernel_is
348# @USAGE: [-lt -gt -le -ge -eq] major_number [minor_number patch_number]
349# @RETURN: true or false
350# @DESCRIPTION:
351# It returns true when the current kernel version satisfies the comparison against the passed version.
352# -eq is the default comparison.
63# 353#
354# @CODE
64# For Example where KV = 2.6.9 355# For Example where KV = 2.6.9
65# kernel_is 2 4 returns false 356# kernel_is 2 4 returns false
66# kernel_is 2 returns true 357# kernel_is 2 returns true
67# kernel_is 2 6 returns true 358# kernel_is 2 6 returns true
68# kernel_is 2 6 8 returns false 359# kernel_is 2 6 8 returns false
69# kernel_is 2 6 9 returns true 360# kernel_is 2 6 9 returns true
70# 361# @CODE
362
71# got the jist yet? 363# got the jist yet?
72 364
73kernel_is() { 365kernel_is() {
74 # if we haven't determined the version yet, we need too. 366 # if we haven't determined the version yet, we need to.
75 get_version; 367 linux-info_get_any_version
76
77 local RESULT
78 RESULT=1
79
80 if [ -n "${1}" ]
81 then
82 [ "${1}" = "${KV_MAJOR}" ] && RESULT=0
83 fi
84
85 if [ -n "${2}" ]
86 then
87 RESULT=1
88 [ "${2}" = "${KV_MINOR}" ] && RESULT=0
89 fi
90
91 if [ -n "${3}" ]
92 then
93 RESULT=1
94 [ "${3}" = "${KV_PATCH}" ] && RESULT=0
95 fi
96 return ${RESULT}
97}
98 368
369 local operator testagainst value x=0 y=0 z=0
370
371 case ${1} in
372 -lt|lt) operator="-lt"; shift;;
373 -gt|gt) operator="-gt"; shift;;
374 -le|le) operator="-le"; shift;;
375 -ge|ge) operator="-ge"; shift;;
376 -eq|eq) operator="-eq"; shift;;
377 *) operator="-eq";;
378 esac
379
380 for x in ${@}; do
381 for((y=0; y<$((3 - ${#x})); y++)); do value="${value}0"; done
382 value="${value}${x}"
383 z=$((${z} + 1))
384
385 case ${z} in
386 1) for((y=0; y<$((3 - ${#KV_MAJOR})); y++)); do testagainst="${testagainst}0"; done;
387 testagainst="${testagainst}${KV_MAJOR}";;
388 2) for((y=0; y<$((3 - ${#KV_MINOR})); y++)); do testagainst="${testagainst}0"; done;
389 testagainst="${testagainst}${KV_MINOR}";;
390 3) for((y=0; y<$((3 - ${#KV_PATCH})); y++)); do testagainst="${testagainst}0"; done;
391 testagainst="${testagainst}${KV_PATCH}";;
392 *) die "Error in kernel-2_kernel_is(): Too many parameters.";;
393 esac
394 done
395
396 [ "${testagainst}" ${operator} "${value}" ] && return 0 || return 1
397}
398
399get_localversion() {
400 local lv_list i x
401
402 # ignore files with ~ in it.
403 for i in $(ls ${1}/localversion* 2>/dev/null); do
404 [[ -n ${i//*~*} ]] && lv_list="${lv_list} ${i}"
405 done
406
407 for i in ${lv_list}; do
408 x="${x}$(<${i})"
409 done
410 x=${x/ /}
411 echo ${x}
412}
413
414# internal variable, so we know to only print the warning once
415get_version_warning_done=
416
417# @FUNCTION: get_version
418# @DESCRIPTION:
419# It gets the version of the kernel inside KERNEL_DIR and populates the KV_FULL variable
420# (if KV_FULL is already set it does nothing).
421#
422# The kernel version variables (KV_MAJOR, KV_MINOR, KV_PATCH, KV_EXTRA and KV_LOCAL) are also set.
423#
424# The KV_DIR is set using the KERNEL_DIR env var, the KV_DIR_OUT is set using a valid
425# KBUILD_OUTPUT (in a decreasing priority list, we look for the env var, makefile var or the
426# symlink /lib/modules/${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${KV_EXTRA}/build).
99get_version() { 427get_version() {
428 local kbuild_output
429
100 # no need to execute this twice assuming KV_FULL is populated. 430 # no need to execute this twice assuming KV_FULL is populated.
101 # we can force by unsetting KV_FULL 431 # we can force by unsetting KV_FULL
102 if [ -n "${KV_FULL}" ] 432 [ -n "${KV_FULL}" ] && return 0
103 then
104 # Lets keep this quiet eh?
105 # einfo "\${KV_FULL} is already set. Not running get_version again"
106 return
107 fi
108 433
109 # if we dont know KV_FULL, then we need too. 434 # if we dont know KV_FULL, then we need too.
110 # make sure KV_DIR isnt set since we need to work it out via KERNEL_DIR 435 # make sure KV_DIR isnt set since we need to work it out via KERNEL_DIR
111 unset KV_DIR 436 unset KV_DIR
112 437
113 # KV_DIR will contain the full path to the sources directory we should use 438 # KV_DIR will contain the full path to the sources directory we should use
439 [ -z "${get_version_warning_done}" ] && \
114 einfo "Determining the location of the kernel source code" 440 qeinfo "Determining the location of the kernel source code"
115 [ -h "${KERNEL_DIR}" ] && KV_DIR="$(readlink -f ${KERNEL_DIR})" 441 [ -h "${KERNEL_DIR}" ] && KV_DIR="$(readlink -f ${KERNEL_DIR})"
116 [ -d "${KERNEL_DIR}" ] && KV_DIR="${KERNEL_DIR}" 442 [ -d "${KERNEL_DIR}" ] && KV_DIR="${KERNEL_DIR}"
117 443
118 if [ -z "${KV_DIR}" ] 444 if [ -z "${KV_DIR}" ]
119 then 445 then
446 if [ -z "${get_version_warning_done}" ]; then
447 get_version_warning_done=1
120 eerror "Unable to find kernel sources at ${KERNEL_DIR}" 448 qeerror "Unable to find kernel sources at ${KERNEL_DIR}"
121 die 449 #qeinfo "This package requires Linux sources."
450 if [ "${KERNEL_DIR}" == "/usr/src/linux" ] ; then
451 qeinfo "Please make sure that ${KERNEL_DIR} points at your running kernel, "
452 qeinfo "(or the kernel you wish to build against)."
453 qeinfo "Alternatively, set the KERNEL_DIR environment variable to the kernel sources location"
454 else
455 qeinfo "Please ensure that the KERNEL_DIR environment variable points at full Linux sources of the kernel you wish to compile against."
456 fi
122 fi 457 fi
123 458 return 1
459 fi
460
461 if [ -z "${get_version_warning_done}" ]; then
462 qeinfo "Found kernel source directory:"
463 qeinfo " ${KV_DIR}"
464 fi
465
466 if [ ! -s "${KV_DIR}/Makefile" ]
467 then
468 if [ -z "${get_version_warning_done}" ]; then
469 get_version_warning_done=1
470 qeerror "Could not find a Makefile in the kernel source directory."
471 qeerror "Please ensure that ${KERNEL_DIR} points to a complete set of Linux sources"
472 fi
473 return 1
474 fi
475
476 # OK so now we know our sources directory, but they might be using
477 # KBUILD_OUTPUT, and we need this for .config and localversions-*
478 # so we better find it eh?
479 # do we pass KBUILD_OUTPUT on the CLI?
480 OUTPUT_DIR="${OUTPUT_DIR:-${KBUILD_OUTPUT}}"
481
482 # keep track of it
483 KERNEL_MAKEFILE="${KV_DIR}/Makefile"
484
485 # Check if the Makefile is valid for direct parsing.
486 # Check status results:
487 # - PASS, use 'getfilevar' to extract values
488 # - FAIL, use 'getfilevar_noexec' to extract values
489 # The check may fail if:
490 # - make is not present
491 # - corruption exists in the kernel makefile
492 local a='' b='' mkfunc='getfilevar'
493 a="$(getfilevar VERSION ${KERNEL_MAKEFILE})"
494 b="$(getfilevar_noexec VERSION ${KERNEL_MAKEFILE})"
495 [[ "${a}" != "${b}" ]] && mkfunc='getfilevar_noexec'
496
497 # And if we didn't pass it, we can take a nosey in the Makefile
498 kbuild_output="$(${mkfunc} KBUILD_OUTPUT ${KERNEL_MAKEFILE})"
499 OUTPUT_DIR="${OUTPUT_DIR:-${kbuild_output}}"
500
124 # And contrary to existing functions I feel we shouldn't trust the 501 # And contrary to existing functions I feel we shouldn't trust the
125 # directory name to find version information as this seems insane. 502 # directory name to find version information as this seems insane.
126 # so we parse ${KV_DIR}/Makefile 503 # so we parse ${KERNEL_MAKEFILE}
127 KV_MAJOR="$(getfilevar VERSION ${KV_DIR}/Makefile)" 504 KV_MAJOR="$(${mkfunc} VERSION ${KERNEL_MAKEFILE})"
128 KV_MINOR="$(getfilevar PATCHLEVEL ${KV_DIR}/Makefile)" 505 KV_MINOR="$(${mkfunc} PATCHLEVEL ${KERNEL_MAKEFILE})"
129 KV_PATCH="$(getfilevar SUBLEVEL ${KV_DIR}/Makefile)" 506 KV_PATCH="$(${mkfunc} SUBLEVEL ${KERNEL_MAKEFILE})"
130 KV_EXTRA="$(getfilevar EXTRAVERSION ${KV_DIR}/Makefile)" 507 KV_EXTRA="$(${mkfunc} EXTRAVERSION ${KERNEL_MAKEFILE})"
508
509 if [ -z "${KV_MAJOR}" -o -z "${KV_MINOR}" -o -z "${KV_PATCH}" ]
510 then
511 if [ -z "${get_version_warning_done}" ]; then
512 get_version_warning_done=1
513 qeerror "Could not detect kernel version."
514 qeerror "Please ensure that ${KERNEL_DIR} points to a complete set of Linux sources."
515 fi
516 return 1
517 fi
518
131 # and in newer versions we can also pull LOCALVERSION if it is set. 519 # and in newer versions we can also pull LOCALVERSION if it is set.
132 KV_LOCAL="$(cat ${KV_DIR}/localversion* 2>/dev/null)$(getfilevar CONFIG_LOCALVERSION ${KV_DIR}/.config | sed 's:"::g')" 520 # but before we do this, we need to find if we use a different object directory.
133 521 # This *WILL* break if the user is using localversions, but we assume it was
522 # caught before this if they are.
523 OUTPUT_DIR="${OUTPUT_DIR:-/lib/modules/${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${KV_EXTRA}/build}"
524
525 [ -h "${OUTPUT_DIR}" ] && KV_OUT_DIR="$(readlink -f ${OUTPUT_DIR})"
526 [ -d "${OUTPUT_DIR}" ] && KV_OUT_DIR="${OUTPUT_DIR}"
527 if [ -n "${KV_OUT_DIR}" ];
528 then
529 qeinfo "Found kernel object directory:"
530 qeinfo " ${KV_OUT_DIR}"
531
532 KV_LOCAL="$(get_localversion ${KV_OUT_DIR})"
533 fi
534 # and if we STILL have not got it, then we better just set it to KV_DIR
535 KV_OUT_DIR="${KV_OUT_DIR:-${KV_DIR}}"
536
537 KV_LOCAL="${KV_LOCAL}$(get_localversion ${KV_DIR})"
538 if linux_config_src_exists; then
539 KV_LOCAL="${KV_LOCAL}$(linux_chkconfig_string LOCALVERSION)"
540 KV_LOCAL="${KV_LOCAL//\"/}"
541
542 # For things like git that can append extra stuff:
543 [ -e ${KV_DIR}/scripts/setlocalversion ] &&
544 linux_chkconfig_builtin LOCALVERSION_AUTO &&
545 KV_LOCAL="${KV_LOCAL}$(sh ${KV_DIR}/scripts/setlocalversion ${KV_DIR})"
546 fi
547
134 # And we should set KV_FULL to the full expanded version 548 # And we should set KV_FULL to the full expanded version
135 KV_FULL="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${KV_EXTRA}${KV_LOCAL}" 549 KV_FULL="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${KV_EXTRA}${KV_LOCAL}"
136 550
137 if [ -z "${KV_FULL}" ] 551 qeinfo "Found sources for kernel version:"
138 then 552 qeinfo " ${KV_FULL}"
139 eerror "We are unable to find a usable kernel source tree in ${KV_DIR}" 553
140 eerror "Please check a kernel source exists in this directory." 554 return 0
141 die 555}
556
557# @FUNCTION: get_running_version
558# @DESCRIPTION:
559# It gets the version of the current running kernel and the result is the same as get_version() if the
560# function can find the sources.
561get_running_version() {
562 KV_FULL=$(uname -r)
563
564 if [[ -f ${ROOT}/lib/modules/${KV_FULL}/source/Makefile ]]; then
565 KERNEL_DIR=$(readlink -f ${ROOT}/lib/modules/${KV_FULL}/source)
566 unset KV_FULL
567 get_version
568 return $?
569 elif [[ -f ${ROOT}/lib/modules/${KV_FULL}/build/Makefile ]]; then
570 KERNEL_DIR=$(readlink -f ${ROOT}/lib/modules/${KV_FULL}/build)
571 unset KV_FULL
572 get_version
573 return $?
142 else 574 else
143 einfo "Found kernel source directory:" 575 KV_MAJOR=$(get_version_component_range 1 ${KV_FULL})
144 einfo " ${KV_DIR}" 576 KV_MINOR=$(get_version_component_range 2 ${KV_FULL})
145 einfo "with sources for kernel version:" 577 KV_PATCH=$(get_version_component_range 3- ${KV_FULL})
146 einfo " ${KV_FULL}" 578 KV_PATCH=${KV_PATCH//-*}
579 [[ -n ${KV_FULL#*-} ]] && [[ -n ${KV_FULL//${KV_FULL#*-}} ]] \
580 && KV_EXTRA="-${KV_FULL#*-}"
147 fi 581 fi
582 return 0
148} 583}
149 584
585# This next function is named with the eclass prefix to avoid conflicts with
586# some old versionator-like eclass functions.
150 587
588# @FUNCTION: linux-info_get_any_version
589# @DESCRIPTION:
590# This attempts to find the version of the sources, and otherwise falls back to
591# the version of the running kernel.
592linux-info_get_any_version() {
593 get_version
594 if [[ $? -ne 0 ]]; then
595 ewarn "Unable to calculate Linux Kernel version for build, attempting to use running version"
596 get_running_version
597 fi
598}
151 599
152 600
153# ebuild check functions 601# ebuild check functions
154# --------------------------------------- 602# ---------------------------------------
155 603
604# @FUNCTION: check_kernel_built
605# @DESCRIPTION:
606# This function verifies that the current kernel sources have been already prepared otherwise it dies.
156check_kernel_built() { 607check_kernel_built() {
157 # if we haven't determined the version yet, we need too. 608 # if we haven't determined the version yet, we need to
609 require_configured_kernel
158 get_version; 610 get_version
159 611
160 if [ ! -f "${KV_DIR}/System.map" ] 612 if [ ! -f "${KV_OUT_DIR}/include/linux/version.h" ]
161 then 613 then
162 eerror "These sources have not yet been compiled." 614 eerror "These sources have not yet been prepared."
163 eerror "We cannot build against an uncompiled tree." 615 eerror "We cannot build against an unprepared tree."
164 eerror "To resolve this, please type the following:" 616 eerror "To resolve this, please type the following:"
165 eerror 617 eerror
166 eerror "# cd ${KV_DIR}" 618 eerror "# cd ${KV_DIR}"
167 eerror "# make oldconfig" 619 eerror "# make oldconfig"
168 eerror "# make bzImage modules modules_install" 620 eerror "# make modules_prepare"
169 eerror 621 eerror
170 eerror "Then please try merging this module again." 622 eerror "Then please try merging this module again."
171 die "Kernel sources need compiling first" 623 die "Kernel sources need compiling first"
172 fi 624 fi
173} 625}
174 626
627# @FUNCTION: check_modules_supported
628# @DESCRIPTION:
629# This function verifies that the current kernel support modules (it checks CONFIG_MODULES=y) otherwise it dies.
175check_modules_supported() { 630check_modules_supported() {
176 # if we haven't determined the version yet, we need too. 631 # if we haven't determined the version yet, we need too.
632 require_configured_kernel
177 get_version; 633 get_version
178 634
179 getfilevar_isset CONFIG_MODULES ${KV_DIR}/.config 635 if ! linux_chkconfig_builtin "MODULES"
180 if [ "$?" != 0 ]
181 then 636 then
182 eerror "These sources do not support loading external modules." 637 eerror "These sources do not support loading external modules."
183 eerror "to be able to use this module please enable \"Loadable modules support\"" 638 eerror "to be able to use this module please enable \"Loadable modules support\""
184 eerror "in your kernel, recompile and then try merging this module again." 639 eerror "in your kernel, recompile and then try merging this module again."
640 die "No support for external modules in ${KV_FULL} config"
641 fi
642}
643
644# @FUNCTION: check_extra_config
645# @DESCRIPTION:
646# It checks the kernel config options specified by CONFIG_CHECK. It dies only when a required config option (i.e.
647# the prefix ~ is not used) doesn't satisfy the directive.
648check_extra_config() {
649 local config negate die error reworkmodulenames
650 local soft_errors_count=0 hard_errors_count=0 config_required=0
651 # store the value of the QA check, because otherwise we won't catch usages
652 # after if check_extra_config is called AND other direct calls are done
653 # later.
654 local old_LINUX_CONFIG_EXISTS_DONE="${_LINUX_CONFIG_EXISTS_DONE}"
655
656 # if we haven't determined the version yet, we need to
657 linux-info_get_any_version
658
659 # Determine if we really need a .config. The only time when we don't need
660 # one is when all of the CONFIG_CHECK options are prefixed with "~".
661 for config in ${CONFIG_CHECK}
662 do
663 if [[ "${config:0:1}" != "~" ]]; then
664 config_required=1
665 break
185 fi 666 fi
667 done
668
669 if [[ ${config_required} == 0 ]]; then
670 # In the case where we don't require a .config, we can now bail out
671 # if the user has no .config as there is nothing to do. Otherwise
672 # code later will cause a failure due to missing .config.
673 if ! linux_config_exists; then
674 ewarn "Unable to check for the following kernel config options due"
675 ewarn "to absence of any configured kernel sources or compiled"
676 ewarn "config:"
677 for config in ${CONFIG_CHECK}; do
678 local_error="ERROR_${config#\~}"
679 msg="${!local_error}"
680 if [[ "x${msg}" == "x" ]]; then
681 local_error="WARNING_${config#\~}"
682 msg="${!local_error}"
683 fi
684 ewarn " - ${config#\~}${msg:+ - }${msg}"
685 done
686 ewarn "You're on your own to make sure they are set if needed."
687 export LINUX_CONFIG_EXISTS_DONE="${old_LINUX_CONFIG_EXISTS_DONE}"
688 return 0
689 fi
690 else
691 require_configured_kernel
692 fi
693
694 einfo "Checking for suitable kernel configuration options..."
695
696 for config in ${CONFIG_CHECK}
697 do
698 # if we specify any fatal, ensure we honor them
699 die=1
700 error=0
701 negate=0
702 reworkmodulenames=0
703
704 if [[ ${config:0:1} == "~" ]]; then
705 die=0
706 config=${config:1}
707 elif [[ ${config:0:1} == "@" ]]; then
708 die=0
709 reworkmodulenames=1
710 config=${config:1}
711 fi
712 if [[ ${config:0:1} == "!" ]]; then
713 negate=1
714 config=${config:1}
715 fi
716
717 if [[ ${negate} == 1 ]]; then
718 linux_chkconfig_present ${config} && error=2
719 elif [[ ${reworkmodulenames} == 1 ]]; then
720 local temp_config="${config//*:}" i n
721 config="${config//:*}"
722 if linux_chkconfig_present ${config}; then
723 for i in ${MODULE_NAMES}; do
724 n="${i//${temp_config}}"
725 [[ -z ${n//\(*} ]] && \
726 MODULE_IGNORE="${MODULE_IGNORE} ${temp_config}"
727 done
728 error=2
729 fi
730 else
731 linux_chkconfig_present ${config} || error=1
732 fi
733
734 if [[ ${error} > 0 ]]; then
735 local report_func="eerror" local_error
736 local_error="ERROR_${config}"
737 local_error="${!local_error}"
738
739 if [[ -z "${local_error}" ]]; then
740 # using old, deprecated format.
741 local_error="${config}_ERROR"
742 local_error="${!local_error}"
743 fi
744 if [[ ${die} == 0 && -z "${local_error}" ]]; then
745 #soft errors can be warnings
746 local_error="WARNING_${config}"
747 local_error="${!local_error}"
748 if [[ -n "${local_error}" ]] ; then
749 report_func="ewarn"
750 fi
751 fi
752
753 if [[ -z "${local_error}" ]]; then
754 [[ ${error} == 1 ]] \
755 && local_error="is not set when it should be." \
756 || local_error="should not be set. But it is."
757 local_error="CONFIG_${config}:\t ${local_error}"
758 fi
759 if [[ ${die} == 0 ]]; then
760 ${report_func} " ${local_error}"
761 soft_errors_count=$[soft_errors_count + 1]
762 else
763 ${report_func} " ${local_error}"
764 hard_errors_count=$[hard_errors_count + 1]
765 fi
766 fi
767 done
768
769 if [[ ${hard_errors_count} > 0 ]]; then
770 eerror "Please check to make sure these options are set correctly."
771 eerror "Failure to do so may cause unexpected problems."
772 eerror "Once you have satisfied these options, please try merging"
773 eerror "this package again."
774 export LINUX_CONFIG_EXISTS_DONE="${old_LINUX_CONFIG_EXISTS_DONE}"
775 die "Incorrect kernel configuration options"
776 elif [[ ${soft_errors_count} > 0 ]]; then
777 ewarn "Please check to make sure these options are set correctly."
778 ewarn "Failure to do so may cause unexpected problems."
779 else
780 eend 0
781 fi
782 export LINUX_CONFIG_EXISTS_DONE="${old_LINUX_CONFIG_EXISTS_DONE}"
186} 783}
187 784
188check_zlibinflate() { 785check_zlibinflate() {
189 # if we haven't determined the version yet, we need too. 786 # if we haven't determined the version yet, we need to
787 require_configured_kernel
190 get_version; 788 get_version
191 789
192 # although I restructured this code - I really really really dont support it! 790 # although I restructured this code - I really really really dont support it!
193 791
194 # bug #27882 - zlib routines are only linked into the kernel 792 # bug #27882 - zlib routines are only linked into the kernel
195 # if something compiled into the kernel calls them 793 # if something compiled into the kernel calls them
196 # 794 #
197 # plus, for the cloop module, it appears that there's no way 795 # plus, for the cloop module, it appears that there's no way
198 # to get cloop.o to include a static zlib if CONFIG_MODVERSIONS 796 # to get cloop.o to include a static zlib if CONFIG_MODVERSIONS
199 # is on 797 # is on
200 798
201local INFLATE 799 local INFLATE
202local DEFLATE 800 local DEFLATE
203 801
204 einfo "Determining the usability of ZLIB_INFLATE support in your kernel" 802 einfo "Determining the usability of ZLIB_INFLATE support in your kernel"
205 803
206 ebegin "checking ZLIB_INFLATE" 804 ebegin "checking ZLIB_INFLATE"
207 getfilevar_isbuiltin CONFIG_ZLIB_INFLATE ${KV_DIR}/.config 805 linux_chkconfig_builtin CONFIG_ZLIB_INFLATE
208 eend $? 806 eend $?
209 [ "$?" != 0 ] && die 807 [ "$?" != 0 ] && die
210 808
211 ebegin "checking ZLIB_DEFLATE" 809 ebegin "checking ZLIB_DEFLATE"
212 getfilevar_isbuiltin CONFIG_ZLIB_DEFLATE ${KV_DIR}/.config 810 linux_chkconfig_builtin CONFIG_ZLIB_DEFLATE
213 eend $? 811 eend $?
214 [ "$?" != 0 ] && die 812 [ "$?" != 0 ] && die
215 813
216
217 local LINENO_START 814 local LINENO_START
218 local LINENO_END 815 local LINENO_END
219 local SYMBOLS 816 local SYMBOLS
220 local x 817 local x
221 818
222 LINENO_END="$(grep -n 'CONFIG_ZLIB_INFLATE y' ${KV_DIR}/lib/Config.in | cut -d : -f 1)" 819 LINENO_END="$(grep -n 'CONFIG_ZLIB_INFLATE y' ${KV_DIR}/lib/Config.in | cut -d : -f 1)"
223 LINENO_START="$(head -n $LINENO_END ${KV_DIR}/lib/Config.in | grep -n 'if \[' | tail -n 1 | cut -d : -f 1)" 820 LINENO_START="$(head -n $LINENO_END ${KV_DIR}/lib/Config.in | grep -n 'if \[' | tail -n 1 | cut -d : -f 1)"
224 (( LINENO_AMOUNT = $LINENO_END - $LINENO_START )) 821 (( LINENO_AMOUNT = $LINENO_END - $LINENO_START ))
225 (( LINENO_END = $LINENO_END - 1 )) 822 (( LINENO_END = $LINENO_END - 1 ))
226 SYMBOLS="$(head -n $LINENO_END ${KERNEL_DIR}/lib/Config.in | tail -n $LINENO_AMOUNT | sed -e 's/^.*\(CONFIG_[^\" ]*\).*/\1/g;')" 823 SYMBOLS="$(head -n $LINENO_END ${KV_DIR}/lib/Config.in | tail -n $LINENO_AMOUNT | sed -e 's/^.*\(CONFIG_[^\" ]*\).*/\1/g;')"
227 824
228 # okay, now we have a list of symbols 825 # okay, now we have a list of symbols
229 # we need to check each one in turn, to see whether it is set or not 826 # we need to check each one in turn, to see whether it is set or not
230 for x in $SYMBOLS ; do 827 for x in $SYMBOLS ; do
231 if [ "${!x}" = "y" ]; then 828 if [ "${!x}" = "y" ]; then
232 # we have a winner! 829 # we have a winner!
233 einfo "${x} ensures zlib is linked into your kernel - excellent" 830 einfo "${x} ensures zlib is linked into your kernel - excellent"
234 return 0 831 return 0
235 fi 832 fi
236 done 833 done
237 834
238 eerror 835 eerror
239 eerror "This kernel module requires ZLIB library support." 836 eerror "This kernel module requires ZLIB library support."
240 eerror "You have enabled zlib support in your kernel, but haven't enabled" 837 eerror "You have enabled zlib support in your kernel, but haven't enabled"
241 eerror "enabled any option that will ensure that zlib is linked into your" 838 eerror "enabled any option that will ensure that zlib is linked into your"
242 eerror "kernel." 839 eerror "kernel."
252 eerror "Please remember to recompile and install your kernel, and reboot" 849 eerror "Please remember to recompile and install your kernel, and reboot"
253 eerror "into your new kernel before attempting to load this kernel module." 850 eerror "into your new kernel before attempting to load this kernel module."
254 851
255 die "Kernel doesn't include zlib support" 852 die "Kernel doesn't include zlib support"
256} 853}
854
855################################
856# Default pkg_setup
857# Also used when inheriting linux-mod to force a get_version call
858# @FUNCTION: linux-info_pkg_setup
859# @DESCRIPTION:
860# Force a get_version() call when inherited from linux-mod.eclass and then check if the kernel is configured
861# to support the options specified in CONFIG_CHECK (if not null)
862linux-info_pkg_setup() {
863 linux-info_get_any_version
864
865 if kernel_is 2 4; then
866 if [ "$( gcc-major-version )" -eq "4" ] ; then
867 echo
868 ewarn "Be warned !! >=sys-devel/gcc-4.0.0 isn't supported with"
869 ewarn "linux-2.4 (or modules building against a linux-2.4 kernel)!"
870 echo
871 ewarn "Either switch to another gcc-version (via gcc-config) or use a"
872 ewarn "newer kernel that supports gcc-4."
873 echo
874 ewarn "Also be aware that bugreports about gcc-4 not working"
875 ewarn "with linux-2.4 based ebuilds will be closed as INVALID!"
876 echo
877 epause 10
878 fi
879 fi
880
881 [ -n "${CONFIG_CHECK}" ] && check_extra_config;
882}

Legend:
Removed from v.1.1  
changed lines
  Added in v.1.81

  ViewVC Help
Powered by ViewVC 1.1.20